gnutls_certificate_set_key(3)

NAME
gnutls_certificate_set_key - API function

SYNOPSIS
#include <gnutls/abstract.h>

int gnutls_certificate_set_key(gnutls_certificate_credentials_t res, const char ** names, int names_size, gnutls_pcert_st * pcert_list, int pcert_list_size, gnutls_privkey_t key);

ARGUMENTS

gnutls_certificate_credentials_t res
    is a gnutls_certificate_credentials_t type.

const char ** names
    is an array of DNS name of the certificate (NULL if none)

int names_size
    holds the size of the names list

gnutls_pcert_st * pcert_list
    contains a certificate list (path) for the specified private key

int pcert_list_size
    holds the size of the certificate list

gnutls_privkey_t key
    is a gnutls_privkey_t key

DESCRIPTION
This function sets a certificate/private key pair in the gnutls_certificate_credentials_t type. This function may be called more than once, in case multiple keys/certificates exist for the server. For clients that want to send more than their own end- entity certificate (e.g., also an intermediate CA cert), the full certificate chain must be provided in pcert_list . Note that the key and the elements of pcert_list will become part of the credentials structure and must not be deallocated. They will be automatically deallocated when the res structure is deinitialized. If that function fails to load the res structure is at an undefined state, it must not be reused to load other keys or certificates. Note that, this function by default returns zero on success and a negative value on error. Since 3.5.6, when the flag GNUTLS_CERTIFICATE_API_V2 is set using gnutls_certificate_set_flags() it returns an index (greater or equal to zero). That index can be used to other functions to refer to the added key-pair.

RETURNS
On success this functions returns zero, and otherwise a negative value on error (see above for modifying that behavior).

SINCE
3.0

REPORTING BUGS
Report bugs to <bugs@gnutls.org>.
Home page: http://www.gnutls.org

COPYRIGHT
Copyright © 2001-2017 Free Software Foundation, Inc., and others.
Copying and distribution of this file, with or without modification, are permitted in any medium without royalty provided the copyright notice and this notice are preserved.

SEE ALSO
The full documentation for gnutls is maintained as a Texinfo manual. If the /usr/share/doc/gnutls/ directory does not contain the HTML form visit

http://www.gnutls.org/manual/